#include <bits/stdc++.h>
#define int long long
using namespace std;

vector<int> tree;
vector<int> a;
void init(int i, int l, int r) {
    if (r - l == 1) {
        tree[i] = a[l];
        return;
    }
    int mid = (l + r) / 2;
    init(2 * i + 1, l, mid);
    init(2 * i + 2, mid, r);
    tree[i] = max(tree[2 * i + 1], tree[2 * i + 2]);
}
int get(int i, int l, int r, int lx, int rx) {
    if (lx <= l && r <= rx) {
        return tree[i];
    }
    if (r <= lx) return 0;
    if (rx <= l) return 0;
    int mid = (l + r) / 2;
    return max(get(2 * i + 1, l, mid, lx, rx), get(2 * i + 2, mid, r, lx, rx));
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);

    int n;
    cin >> n;
    a.resize(n);
    tree.resize(4 * n);
    for (int i = 0; i < n; i++) {
        cin >> a[i];
    }
    init(0, 0, n);
    vector<vector<int>> mp(n);
    vector<int> q(n - 1);
    for (int i = 0; i < n - 1; i++) {
        cin >> q[i];
        q[i]--;
        mp[i].push_back(i);
    }
    mp[n - 1] = {n - 1};
    for (auto k : q) {
        vector<int> nw;
        for (auto x : mp[k]) {
            nw.push_back(x);
        }
        for (auto x : mp[k + 1]) {
            nw.push_back(x);
        }
        for (int i = k + 2; i < mp.size(); i++) {
            mp[i - 1] = mp[i];
        }
        mp.pop_back();
        mp[k] = nw;
        int ans = 0;
        for (auto x : nw) {
            int l = get(0, 0, n, nw[0], x + 1);
            int r = get(0, 0, n, x, nw.back() + 1);
            ans += min(l, r) - a[x];
        }
        cout << ans << endl;
    }
}