#include <bits/stdc++.h>
#define int long long
using namespace std;

vector<int> tree;
vector<int> a;
void init(int i, int l, int r) {
    if (r - l == 1) {
        tree[i] = a[l];
        return;
    }
    int mid = (l + r) / 2;
    init(2 * i + 1, l, mid);
    init(2 * i + 2, mid, r);
    tree[i] = max(tree[2 * i + 1], tree[2 * i + 2]);
}
int get(int i, int l, int r, int lx, int rx) {
    if (lx <= l && r <= rx) {
        return tree[i];
    }
    if (r <= lx) return 0;
    if (rx <= l) return 0;
    int mid = (l + r) / 2;
    return max(get(2 * i + 1, l, mid, lx, rx), get(2 * i + 2, mid, r, lx, rx));
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);

    int n;
    cin >> n;
    a.resize(n);
    tree.resize(4 * n);
    for (int i = 0; i < n; i++) {
        cin >> a[i];
    }
    init(0, 0, n);
    vector<int> mp(n);
    vector<int> q(n - 1);
    for (int i = 0; i < n - 1; i++) {
        cin >> q[i];
        q[i]--;
        mp[i] = i;
    }
    mp[n - 1] = n - 1;
    for (auto k : q) {
        int start = lower_bound(mp.begin(), mp.end(), k) - mp.begin();
        int j = -1;
        for (int i = upper_bound(mp.begin(), mp.end(), k) - mp.begin(); i < mp.size(); i++) {
            if (mp[i] == k + 1) {
                j = i;
            }
            mp[i]--;
        }
        int ans = 0, mx = a[start];
        for (; start <= j; start++) {
            mx = max(mx, a[start]);
            ans += min(mx, get(0, 0, n, start, j + 1)) - a[start];
        }
        cout << ans << endl;
    }
}